      Subroutine df_mie_melt(freq,temp,lwc,iwc,kext,asym,salb,pbck)
      Implicit NONE
c
c This subroutine synthesizes the radiative properties within
c the melting layer. The number fraction of snow flakes to the rain 
c and snow mixture (=f_snow) is assumed to be linearly decreased 
c downward from the 0C height. 
c The number of sublayers is given by "nsublayer".
c
c
      real *4 freq,temp
      real *4 lwc,iwc
      real *4 kext,asym,salb,pbck
      real *4 kext_s,asym_s,salb_s,pbck_s
      real *4 f_snow
      integer nsublyr,i
      Parameter ( nsublyr = 10 )
c
      kext = 0.
      asym = 0.
      salb = 0.
      pbck = 0.
      if (lwc .lt. 0.001 .and. iwc .lt. 0.001) return
      Do i = 1 , nsublyr
         f_snow = float(i) / nsublyr - .5 / nsublyr
         Call mie_melt(freq, temp, iwc, lwc, f_snow,
     &                 kext_s, salb_s, asym_s, pbck_s)
         kext = kext + kext_s
         asym = asym + asym_s
         salb = salb + salb_s
         pbck = pbck + pbck_s
      End do
      kext = kext / nsublyr
      asym = asym / nsublyr
      salb = salb / nsublyr
      pbck = pbck / nsublyr
c
      Return
      End
