      subroutine radar_echo(ngridx, ngridy, umu, nlyr, 
     $      lyrtemp, lyrhgt, kexttot, sbacktot, freqncy,
     $      dBZ, PIA)
      Implicit NONE
C     
C     Hiro Masunaga (Sep/02)
C     
C
      include  '../GRIDparameters.inc'
     
      integer  ngridx, ngridy, nlyr, nx, ny, nz
      real     lyrtemp(mxgridx,mxgridy,0:mxlyr)
      real     lyrhgt(0:mxlyr),umu

      real  kexttot(mxgridx,mxgridy,mxlyr)
      real  sbacktot(mxgridx,mxgridy,mxlyr)
      REAL  dBZ(mxgridx,mxgridy,mxlyr)
      REAL  PIA(mxgridx,mxgridy)
      Real  dBZCRM(mxgridx,mxgridy)

C local variables
C   atten(z=surface to TOA) : attenuation measured from TOA
C   tauext(z=surface to TOA): Extinction optical thickness
C                             measured from TOA
C   lambda: Radar echo wavelength [mm]
C
      real tauext(0:nlyr), ln10, pi, K2, lambda
      real lge, freqncy, dtau
      Parameter ( pi = 3.14159265 )
      Parameter ( K2 = .9255)
c
      lge = log10(2.71828183)
      lambda = 2.997925e2 / freqncy
c
      do 10 nx = 1, ngridx
        do 10 ny = 1, ngridy
           tauext(nlyr) = 0.
           do 20 nz = nlyr, 1, -1
              dtau = kexttot(nx,ny,nz)*(lyrhgt(nz)-lyrhgt(nz-1))/umu
              tauext(nz-1) = tauext(nz)  + dtau
              If (sbacktot(nx,ny,nz).le.0.) then
                 dBZ(nx,ny,nz) = -999.
              Else
c
c Units : Z in [mm6/m3], lambda in [mm], sbacktot in [km^-1]
c
                 dBZ(nx,ny,nz) = 10*(4*log10(lambda) + 
     &                                 log10(sbacktot(nx,ny,nz)) -
     &                                 log10(K2) - 5*log10(pi) - 
     &                                 2*tauext(nz)*lge + 3. +
     &                                 log10(1.-exp(-2*dtau)) -
     &                                 log10(2*dtau))
              Endif
 20        Continue
           PIA(nx,ny) = 20*tauext(0)*lge
 10   Continue
c              
      Return
      End

