      SUBROUTINE CHKRT(INDA,INDT,INDP,IMTHD,NDA,NA1U,AM1U,NA0,AM0
     &,NFI,FI,NLN,THK,OMG,NLGN1,G,NANG,ANG,PHSF,EPSP,EPSU,GALB,FSOL
     &,NPLK1,CPLK,BGND,NTAU,UTAU,AMUA,WA,DPT,MXLGN2,ERR)
C CHECK-IN VARIABLES FOR -RTRN1- AND SET SOME VARIABLES.
C--- HISTORY
C 90. 1.20   CREATED
C    11.22   ADD: ELSE MXLGN2=2*NDA+1
C    12. 1   ADD LOOP-19.
C 93. 5. 4   Delete the condition GALB<=1 because GALB is used as wind
C            velocity when INDG>0.
C INPUT/OUTPUT SEE MAIN ROUTINE.
C
      include 'VISIRparameters.inc'
c
c      PARAMETER (KNA1U =10)
c      PARAMETER (KNA0  =10)
c      PARAMETER (KNDM  =10)
c      PARAMETER (KNFI  =10)
c      PARAMETER (KLGN1 =50)
c      PARAMETER (KNLN  =50)
c      PARAMETER (KNTAU =51)
c      PARAMETER (KPLK1 =2)
c      PARAMETER (KNANG =80)
C
c      PARAMETER (KNLN1=KNLN+1,KLGT1=2*KNDM)
      PARAMETER (PI=3.141592654)
C AREAS FOR THIS ROUTINE
      CHARACTER ERR*(*)
      DIMENSION AM1U(KNA1U),AM0(KNA0),FI(KNFI),THK(KNLN),OMG(KNLN)
     &,NLGN1(KNLN),G(KLGN1,KNLN),ANG(KNANG),PHSF(KNANG,KNLN)
     &,CPLK(KPLK1,KNLN),UTAU(KNTAU)
      DIMENSION AMUA(KNDM),WA(KNDM),DPT(KNLN1)
      DIMENSION CCP(3)
      CALL CPCON(CCP)
      EPS=CCP(1)*10
      ERR=' '
C EPSP, EPSU, FSOL
      IF(EPSP.LT.0) THEN
        ERR='ILLEGAL VALUE OF EPSP'
        RETURN
      ENDIF
      IF(EPSU.LT.0) THEN
        ERR='ILLEGAL VALUE OF EPSU'
        RETURN
      ENDIF
      IF(FSOL.LT.0) THEN
        ERR='ILLEGAL VALUE OF FSOL'
        RETURN
      ENDIF
C INDA
      IF(INDA.LT.0 .OR. INDA.GT.2) THEN
        ERR='ILLEGAL VALUE OF INDA'
        RETURN
      ENDIF
C INDT
      IF(INDT.LT.0 .OR. INDT.GT.2) THEN
        ERR='ILLEGAL VALUE OF INDT'
        RETURN
      ENDIF
C INDP
      IF(INDP.LT.-1 .OR. INDP.GT.1) THEN
        ERR='ILLEGAL VALUE OF INDP'
        RETURN
       ENDIF
C IMTHD
      IF(IMTHD.GT.3) THEN
        ERR='ILLEGAL VALUE OF IMTHD'
        RETURN
      ENDIF
C NDA
      IF(NDA.LE.0 .OR. NDA.GT.KNDM) THEN
        ERR='ILLEGAL VALUE OF NDA'
        RETURN
      ENDIF
C SET QUADRATURE
      CALL QUADA(NDA,AMUA,WA)
C NA0, AM0
      IF(NA0.LE.0 .OR. NA0.GT.KNA0) THEN
        ERR='ILLEGAL VALUE OF NA0'
        RETURN
      ENDIF
      DO 20 I=1,NA0
      IF(AM0(I).LE.0.0 .OR. AM0(I).GT.1.0) THEN
        ERR='ILLEGAL VALUE OF AM0'
        RETURN
      ENDIF
   20 CONTINUE
C INDA, AM1U, FI
      IF(INDA.GT.0) THEN
        IF(NFI.LE.0 .OR. NFI.GT.KNFI) THEN
          ERR='ILLEGAL VALUE OF NFI'
          RETURN
        ENDIF
        IF(INDA.EQ.2) NA1U=2*NDA
        IF(NA1U.LE.0 .OR. NA1U.GT.KNA1U) THEN
          ERR='ILLEGAL VALUE OF NA1U'
          RETURN
        ENDIF
        IF(INDA.EQ.2) THEN
          DO 1 I=1,NDA
          AM1U(I)        = -AMUA(I)
    1     AM1U(NA1U+1-I) =  AMUA(I)
        ENDIF
      ENDIF
C NLN
      IF(NLN.LE.0 .OR. NLN.GT.KNLN) THEN
        ERR='ILLEGAL VALUE OF NLN'
        RETURN
      ENDIF
      DPT(1)=0
      DO 17 L=1,NLN
   17 DPT(L+1)=DPT(L)+THK(L)
C NTAU
      IF(INDT.EQ.2) NTAU=NLN+1
      IF(NTAU.LE.0 .OR. NTAU.GT.KNTAU) THEN
        ERR='ILLEGAL VALUE OF NTAU'
        RETURN
      ENDIF
C UTAU
      IF(INDT.EQ.2) THEN
        DO 3 IT=1,NTAU
    3   UTAU(IT)=DPT(IT)
      ENDIF
C NLGN1,  MXLGN2=MAX(NLGN1)
      IF(INDP.LE.0 .OR. (INDA.GT.0 .AND. IMTHD.EQ.3)) THEN
        MXLGN2=1
        DO 4 L=1,NLN
        N1=NLGN1(L)
        IF(N1.LE.0 .OR. N1.GT.KLGN1) THEN
          ERR='ILLEGAL VALUE OF NLGN1'
          RETURN
        ENDIF
        MXLGN2=MAX(MXLGN2,N1)
    4   CONTINUE
       ELSE
        MXLGN2=2*NDA+1
      ENDIF
C NANG
      IF(INDP.GT.0 .OR. (IMTHD.GE.1 .AND. INDA.GE.1)) THEN
        IF(NANG.LE.3 .OR. NANG.GT.KNANG) THEN
          ERR='YOU SHOULD SET AT LEAST FOUR ANGLES FOR THIS CONDITION'
          RETURN
        ENDIF
        DO 12 I=2,NANG
          IF(ANG(I).LE.ANG(I-1)) THEN
            ERR='YOUR SHOULD SET SCATTERING ANGLE FROM 0 TO 180 DEGREES'
            RETURN
          ENDIF
   12   CONTINUE
      ENDIF
C CHECK ORDER OF DPT AND UTAU.
      DO 5 L=1,NLN
      IF(DPT(L+1).LT.DPT(L)) THEN
        ERR='DPT SHOULD BE SET FROM TOP TO BOTTOM'
        RETURN
      ENDIF
    5 CONTINUE
      IF(NTAU.GE.2) THEN
        DO 6 IT=2,NTAU
        IF(UTAU(IT).LT.UTAU(IT-1)) THEN
          ERR='UTAU SHOULD BE SET FROM TOP TO BOTTOM'
          RETURN
        ENDIF
    6   CONTINUE
      ENDIF
      DO 19 IT=1,NTAU
      IF(UTAU(IT).GT.DPT(NLN+1)) THEN
        IF(ABS(UTAU(IT)-DPT(NLN+1)).LE.EPS) THEN
          UTAU(IT)=DPT(NLN+1)
         ELSE
          ERR='UTAU IS OUT OF BOUNDS'
          RETURN
        ENDIF
      ENDIF
   19 CONTINUE
C RESET CPLK AND BGND, GALB
      IF(GALB.LT.0.0) THEN
        ERR='ILLEGAL VALUE OF GALB'
        RETURN
      ENDIF
      IF(NPLK1.GT.KPLK1) THEN
        ERR='TOO LARGE -NPLK1-, CHANGE -KPLK1-'
        RETURN
       ELSE
        IF(NPLK1.LE.0) THEN
          BGND=0
          DO 18 L=1,NLN
          DO 18 K1=1,NPLK1
   18     CPLK(K1,L)=0
        ENDIF
      ENDIF
      RETURN
      END
