      FUNCTION ERFC(X)
C Complementary error function=(2/sqrt(pi) integral(x,inf) exp(-t**2)dt
C 92.12.22: Created BY NAKAJIMA
C--- INPUT
C X       R      Independent variable 0 to inf
C--- OUTPUT
C ERFC   RF      Complementary error function
C
      PARAMETER (C1 = 7.05230784E-2, C2 = 4.22820123E-2)
      PARAMETER (C3 = 9.2705272E-3,  C4 = 1.520143E-4)
      PARAMETER (C5 = 2.765672E-4,   C6 = 4.30638 E-5)
      V=ABS(X)
      IF(V.LE.7) THEN
        ERFC=1.0/(1+V*(C1+V*(C2+V*(C3+V*(C4+V*(C5+C6*V))))))**16
       ELSE
        ERFC=0
      ENDIF
      IF(X.LT.0) ERFC=2-ERFC
      RETURN
      END
