      SUBROUTINE LGNDF3(LMAX1,N,X,Y,G)
C
C LEGENDRE EXPANSION (SAME AS LGNDF2 BUT GENERATING G-MOMENTS).
C--- HISTORY
C 90. 1.20 CREATED FROM LGNDF2, USE EXPFN.
C          DIRECTION OF INTEGRATION FROM X(1) TO X(N).
C 91. 2.16 STRIP NG FROM SAVE STATEMENT.
C 92. 4. 3 KILL THE STATEMENT OF GW=GW/2 AFTER QGAUSN
C     6.22 ADD GW/2 AGAIN BECAUSE THE ABOVE CHANGE IS MISTAKE
C--- INPUT
C LMAX1      I      MAXIMUM ORDER + 1.
C N          I      NUMBER OF DATA ON (-1, 1). .GE. 4.
C X        R(NA)    INDEPENDENT VARIABLES ON (-1, 1)
C Y        R(NA)    Y(X).
C--- OUTPUT
C G    R(LMAX1)     Y = SUM(L1=1,LMAX1) (2*L1-1)*G(L1)*PL(L1)
C                      WHERE PL(L1) IS (L1-1)TH ORDER LEGENDRE
C                      POLYNOMIAL.
C$ENDI
      SAVE INIT,GW,GX
C VARIABLES FOR THE ROUTINE.
      DIMENSION X(*),Y(*),G(*)
C WORKING AREAS.
      PARAMETER (PI=3.141592653589793, RAD=PI/180.0)
      PARAMETER (NG=5)
      DIMENSION GX(NG),GW(NG)
      DATA INIT/1/
C SHIFTED GAUSSIAN QUADRATURE.
      IF(INIT.GE.1) THEN
        INIT=0
        CALL QGAUSN(GW,GX,NG)
        DO 1 I=1,NG
    1   GW(I)=GW(I)/2
      ENDIF
C CLEAR
      DO 2 L1=1,LMAX1
    2 G(L1)=0
C LOOP FOR ANGLE
      DO 3 I=1,N-1
C CUBIC INTERPOLATION
      IF(I .LE. 2) THEN
        I1=1
        I4=4
       ELSE
        IF(I .LE. N-2) THEN
          I1=I-1
          I4=I+2
         ELSE
          I1=N-3
          I4=N
        ENDIF
      ENDIF
CC
      I2=I1+1
      I3=I2+1
      X1=X(I1)
      X2=X(I2)
      X3=X(I3)
      X4=X(I4)
      IF(   (Y(I1) .LE. 0) .OR. (Y(I2) .LE. 0) .OR. (Y(I3) .LE. 0)
     & .OR. (Y(I4) .LE. 0) ) THEN
        ISIGN=-1
        ALP1=Y(I1)
        ALP2=Y(I2)
        ALP3=Y(I3)
        ALP4=Y(I4)
       ELSE
        ISIGN=1
        ALP1=LOG(Y(I1))
        ALP2=LOG(Y(I2))
        ALP3=LOG(Y(I3))
        ALP4=LOG(Y(I4))
      ENDIF
C LOOP FOR GAUSSIAN INTEGRATION
      DO 4 J=1,NG
CC INTERPOLATED VALUE OF Y
      XX=X(I)+GX(J)*(X(I+1)-X(I))
      WW=GW(J)*(X(I+1)-X(I))
      PP=(XX-X2)*(XX-X3)*(XX-X4)/(X1-X2)/(X1-X3)/(X1-X4)*ALP1
     &  +(XX-X1)*(XX-X3)*(XX-X4)/(X2-X1)/(X2-X3)/(X2-X4)*ALP2
     &  +(XX-X1)*(XX-X2)*(XX-X4)/(X3-X1)/(X3-X2)/(X3-X4)*ALP3
     &  +(XX-X1)*(XX-X2)*(XX-X3)/(X4-X1)/(X4-X2)/(X4-X3)*ALP4
      IF(ISIGN .EQ. 1) PP=EXPFN(PP)
C LEGENDRE SUM
      PL1=0
      PL=1
      G(1)=G(1)+PP*WW
      IF(LMAX1.GE.2) THEN
        DO 5 L1=2,LMAX1
        PL2=PL1
        PL1=PL
        PL=((2*L1-3)*XX*PL1-(L1-2)*PL2)/(L1-1)
    5   G(L1)=G(L1)+PP*PL*WW
      ENDIF
    4 CONTINUE
    3 CONTINUE
      RETURN
      END
      FUNCTION PLGD(INIT,X)
C LEGENDRE POLYNOMIALS
C--- HISTORY
C 87.11.12 CREATED
C 90. 1.16 SAVE STATEMENT
C--- INPUT
C INIT   I    IF 1 THEN L=0
C             IF 0 THEN L=L+1
C X      R    (-1,1)
C--- OUT
C INIT=0
C$ENDI
C
      SAVE L,PL,PL1,PL2
      IF(INIT.GT.0) THEN
        INIT=0
        L=-1
      ENDIF
      L=L+1
      IF(L.EQ.0) THEN
        PL=1
       ELSE
        IF(L.EQ.1) THEN
          PL1=PL
          PL=X
         ELSE
          PL2=PL1
          PL1=PL
          PL=((2*L-1)*X*PL1-(L-1)*PL2)/REAL(L)
        ENDIF
      ENDIF
      PLGD=PL
      RETURN
      END
      SUBROUTINE PLGND(M1,MMX1,NX,NX0,X,PL)
C NORMALIZED ASSOCIATED LEGENDRE POLYNOMIALS
C------ HISTORY
C 1987.03.04
C------ INPUT VARIABLES
C VARIABLE  TYPE    INTERPRETATION
C M1         I      ORDER OF THE FOURIER SERIES + 1
C MMX1       I      MAX ORDER OF M  + 1
C NX         I      NBR OF X
C NX0        I      DECLARED NBR OF NX
C X       R(NX)     XI, I=1,NX
C------ OUTPUT VARIABLES
C PL      R(NX0,    NORMALIZED ASSOCIATED LEGENDRE POLYNOMIALS
C           MMX1)
C$ENDI
C------ GLOBAL PARAMETER
      PARAMETER (PI=3.141592653)
C------ VARIABLES FOR THE ROUTINE
      DIMENSION X(*),PL(NX0,*)
C------ NORMALIZED ASSOCIATED LEGENDRE POLYNOMIALS.
C  CC=P(M,L,X)*SQRT((L-M)|/(L+M)|), WHERE X= COS(MU).
      M=M1-1
      DO 15 L1=M1,MMX1
      L=L1-1
      IF(L-(M+1)) 16,17,18
   16 IF(M) 21,21,22
   21 DO 2 I=1,NX
    2 PL(I,L1)=1.0
      GOTO 15
   22 K=2
      ETA=1.0
      DO 1 J=1,M
      EPSI=1.0-1.0/REAL(K)
      ETA=ETA*EPSI
    1 K=K+2
      ETA=SQRT(ETA)
      DO 24 I=1,NX
      IF(X(I).GE.1.0) THEN
      PL(I,L1)=0.0
      ELSE
      EXPCC=(REAL(M)*LOG(ABS(1.0-X(I)**2)))/2.0
      IF(EXPCC.LE.-100.0) THEN
      PL(I,L1)=0.0
      ELSE
      PL(I,L1)=ETA*EXP(EXPCC)
      ENDIF
      ENDIF
   24 CONTINUE
      GO TO 15
   17 C0=SQRT(REAL(2*M+1))
      DO 26 I=1,NX
   26 PL(I,L1)=C0*PL(I,L1-1)*X(I)
      C0=SQRT(REAL((L-M)*(L+M)))
      GO TO 15
   18 C1=SQRT(REAL((L-M)*(L+M)))
      C2=REAL(2*L-1)
      DO 27 I=1,NX
   27 PL(I,L1)=(C2*X(I)*PL(I,L1-1)-C0*PL(I,L1-2))/C1
      C0=C1
   15 CONTINUE
      RETURN
      END
