      SUBROUTINE MULTI(ND,CD,CC,ERR)
C CALCULATION OF MULTIPLE REFLECTION BETWEEN TWO LAYERS.
C--- HISTORY
C 86.10.15  CHECK OK.
C 89.10.30  RE-EDIT.
C 94. 5. 7  ERR*64 -> ERR*(*)
C--- INPUT
C ND          I     NO. OF STREAMS AT THE INTERFACE BETWEEN TWO LAYERS.
C CD      R(KNDM,   R = R1 * R2.
C           KNDM)
C--- OUTPUT
C CC      R(KNDM,   CC = ( 1 - CD )**-1 = 1 + CD + CD**2 + CD**3 + ...
C           KNDM)
C ERR     C*64      ERROR INDEX.
C--- PARAMETER
C KNDM        I     NUMBER OF QUADRATURE POINTS.
C--- AREAS FOR THIS ROUTINE
C
      Include 'VISIRparameters.inc'
c
C      PARAMETER (KNDM  =10)
C
      CHARACTER ERR*(*)
      DIMENSION CD(KNDM,KNDM),CC(KNDM,KNDM)
C--- WORKING AREA
C      PARAMETER (KNDM2=2*KNDM)
      DIMENSION IW(KNDM2)
C---
      DO 1 I=1,ND
      DO 2 J=1,ND
    2 CC(I,J)= -CD(I,J)
    1 CC(I,I)=1 - CD(I,I)
C INVERSION OF -CC-.
      EPS=0
      CALL TNVSS2(ND,CC,DT,EPS,KNDM,IW,ERR)
      IF(ERR.NE.' ') ERR='ERROR IN MULTI'
      RETURN
      END
