      FUNCTION TRKF(AMTP,TAUM,TWGP,TX)
C K-DISTRIBUTION TRANSMITTANCE FOR EFFECTIVE ABSORBER AMOUNT
C   - W*AMTP-
C--- HISTORY
C 92. 6.30 CREATED
C--- INPUT
C AMTP     R(11)    SCALED ABSORBER AMOUNT FOR EACH BAND
C TX       R(11)    ABSORPTION OPTICAL THICKNESS FOR
C                    CONTINUUM ABSORPTION
C TAUM   R(3,11)    K-VALUES IN THREE TERM K-DISTRIBUTION MODEL
C TWGP   R(3,11)    K-DISTRIBUTIONS
C--- OUTPUT
C TR         R      TRANSMITTANCE
      DIMENSION AMTP(28),TAUM(3,28),TWGP(3,28),TX(28)
      TRKF=0
      DO 1 K=1,3
      TAUM1=0
      TWGP1=0
      DO 2 M=1,11
        TAUM1= TAUM1 + AMTP(M)*TAUM(K,M)
    2   TWGP1= TWGP1 + AMTP(M)*TWGP(K,M)
      IF(TAUM1 .NE. 0) THEN
        TWGP1 = TWGP1 / TAUM1
       ELSE
        TWGP1=1/3.0
      ENDIF
    1 TRKF=TRKF+TWGP1 * EXP(-TAUM1)
C ADD N2 CONTINUUM
      EX=TX(22)
      DO 3 M=1,11
    3 EX=EX+TX(M)
      TRKF=TRKF*EXP(-EX)
      RETURN
      END
